/// A simple Dart library that provides a comprehensive set of utilities for
/// working with music theory concepts.
library music_notes;

export 'src/chordable.dart';
export 'src/harmony/chord.dart';
export 'src/harmony/chord_pattern.dart';
export 'src/harmony/harmonic_function.dart';
export 'src/interval/interval.dart';
export 'src/interval/interval_class.dart';
export 'src/interval/quality.dart';
export 'src/interval/size.dart';
export 'src/key/key.dart';
export 'src/key/key_signature.dart';
export 'src/key/mode.dart';
export 'src/music.dart';
export 'src/note/accidental.dart';
export 'src/note/base_note.dart';
export 'src/note/closest_pitch.dart';
export 'src/note/frequency.dart';
export 'src/note/hearing_range.dart';
export 'src/note/note.dart';
export 'src/note/pitch.dart';
export 'src/note/pitch_class.dart';
export 'src/scalable.dart';
export 'src/scale/scale.dart';
export 'src/scale/scale_degree.dart';
export 'src/scale/scale_pattern.dart';
export 'src/transposable.dart';
export 'src/tuning/cent.dart';
export 'src/tuning/equal_temperament.dart';
export 'src/tuning/just_intonation.dart';
export 'src/tuning/ratio.dart';
export 'src/tuning/tuning_system.dart';
